<?php

namespace Dj3c1t\AppBundle\Service\Listener;

use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpKernel\Exception\HttpExceptionInterface;
use Symfony\Component\DependencyInjection\ContainerInterface as Container;

class RequestListener {

    private $container;

    public function __construct(Container $container) {
        $this->container = $container;
    }

    public function onKernelRequest(GetResponseEvent $event) {
        $im = $this->container->get('dj3c1t_app.install_manager');
        if(!$im->isNotWritableRequest() && $im->checkWriteAccess()) {
            $event->setResponse(
                $im->redirectToNotWritable()
            );
            return;
        }
        if(!$im->isInstalled() && !$im->isInstallRequest()) {
            $event->setResponse(
                $im->redirectToInstall()
            );
        }
    }

}
