<?php

namespace Dj3c1t\SourceMLBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class ImportController extends Controller {

    public function previousVersionAction(Request $request) {
        $importPreviousVersion = $this->get('sourceml.import_previous_version');
        if(php_sapi_name() !== 'cli') {
            return $this->render(
                'Dj3c1tSourceMLBundle:Import:index.html.twig'
            );
        }
        try {
            $importPreviousVersion->init();
            $importPreviousVersion->import();
            $importPreviousVersion->log("import done");
        }
        catch(\Exception $e) {
            $importPreviousVersion->log(" ERROR ".$e->getMessage());
        }
        return new Response();
    }

    public function doImportAction(Request $request) {
        $importPreviousVersion = $this->get('sourceml.import_previous_version');
        try {
            $importPreviousVersion->init();
            $importPreviousVersion->import();
            $importPreviousVersion->log("import done");
            $this->get('session')->getFlashBag()->add('success', "L'upgrade s'est terminé avec succès");
        }
        catch(\Exception $e) {
            $importPreviousVersion->log(" ERROR ".$e->getMessage());
            $this->get('session')->getFlashBag()->add('error', "L'upgrade s'est terminé avec des erreurs");
        }
        return $this->render(
            'Dj3c1tSourceMLBundle:Import:logs.html.twig',
            array(
                "logs" => $importPreviousVersion->getLogs(),
            )
        );
    }

}
