<?php

namespace Dj3c1t\SourceMLBundle\Controller\Source;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;

use Dj3c1t\SourceMLBundle\Entity\Author;

class AuthorController extends Controller {

    public function indexAction(Request $request) {
        $em = $this->get('doctrine')->getManager();
        $query = $em->createQuery("
            SELECT a FROM Dj3c1tSourceMLBundle:Author a
            ORDER BY a.publicationDate DESC
        ");
        $authors = $this->get('knp_paginator')->paginate(
            $query,
            $request->query->getInt('page', 1),
            36
        );
        return $this->render(
            'Dj3c1tSourceMLBundle:Source:Author/index.html.twig',
            array(
                'authors' => $authors
            )
        );
    }

    public function viewAction(Author $author) {
        $albums = $query = $this->get('sourceml.source_manager')->getSourceQuery(
            array(
                "sourceType" => "album",
                "author" => $author->getId(),
            )
        )->getResult();
        return $this->render(
            'Dj3c1tSourceMLBundle:Source:Author/view.html.twig',
            array(
                "author" => $author,
                'albums' => $albums
            )
        );
    }

}
