<?php

namespace Dj3c1t\SourceMLBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class AuthorType extends AbstractType {

    public function buildForm(FormBuilderInterface $builder, array $options) {
        $builder->add(
            'name',
            'text',
            array(
                'label' => 'Name'
            )
        );
        $builder->add(
            'description',
            'textarea',
            array(
                'label' => 'Description'
            )
        );
    }

    public function getName() {
        return 'sourceml_author';
    }

    public function configureOptions(OptionsResolver $resolver) {
        $resolver->setDefaults(
            array(
                'data_class' => 'Dj3c1t\SourceMLBundle\Entity\Author',
                'translation_domain' => 'sourceml',
            )
        );
    }

}
