<?php

/*

    Script de migration des données d'une installation en
    version 1 de SourceML vers une installation en version 2

    UTILISATION DU SCRIPT :

    1)  Faites un backup général de votre ancienne installation
        de SourceML (les dossiers, les fichiers, ainsi qu'un dump
        SQL de la base de données si votre ancienne installation
        utilise MySql).

    2)  Installez la nouvelle version de SourceML.

        Enlevez de votre site les dossiers et les fichiers de
        l'ancienne installation, à l'exception des dossiers "mw"
        et "content".

        Si vous utilisez MySql, laissez les tables dans la base.

        Puis uploadez la nouvelle version sur votre hébergement,
        de manière à ce que le dossier "web" de la nouvelle
        installation contienne les dossiers "mw" et "content" de
        l'ancienne installation.

        Vous pouvez renomer le dossier "web" de la nouvelle
        installation pour l'adpater à votre configuration. Voir
        la documentation pour plus de détails sur l'installation :

        http://www.sourceml.com/index.php?id=8&e=pages/view/page

    3)  La méthode de cryptage des mots de passe change entre la
        version 1 et la version 2 de SourceML. Lors de l'upgrade,
        les mots de passe des utilisateurs sont regénérés.

        Si vous souhaitez qu'un email automatique soit envoyé aux
        utilisateurs, pour leur communiquer leur nouveau mot de passe,
        éditez le fichier :

        previous.version.pathes.php

    4)  Lancez l'upgrade

        a)  En utilisant votre navigateur

            Rendez-vous avec votre navigateur à l'adresse :

            http://votre.site.com/app.php/import/previous_version

            Et cliquez sur le bouton "Lancer l'upgrade"

        b)  En ligne de commande

            Si vous préférez lancer l'upgrade en ligne de commande,
            rendez-vous dans le dossier web de votre nouvelle
            installation et lancez le script :
            
            php import.previous.version.php

    5)  lorsque la migration est terminée, effacez les dossier "mw" et
        "content" du dossier "web", ainsi que les tables de l'ancienne base
        si vous utilisiez MySql dans l'ancienne installation.

*/

use Symfony\Component\ClassLoader\ApcClassLoader;
use Symfony\Component\HttpFoundation\Request;

error_reporting(E_ALL ^ E_NOTICE);

if(php_sapi_name() !== 'cli') {
    echo "this script is for command line only\n";
    return;
}

$loader = require_once dirname(__DIR__).'/app/bootstrap.php.cache';
require_once dirname(__DIR__).'/app/AppKernel.php';
$kernel = new AppKernel('prod', false);
$kernel->loadClassCache();

$request = Request::create('/import/previous_version', 'GET');
echo "\n";
echo "SourceML data import from version 1 to version 2\n";
echo "\n";
$response = $kernel->handle($request);
echo "\n";
